package co.yixiang.yshop.module.member.service.usertag;

import java.util.*;
import javax.validation.*;

import co.yixiang.yshop.module.member.controller.admin.usertag.vo.*;
import co.yixiang.yshop.module.member.dal.dataobject.usertag.UserTagDO;
import co.yixiang.yshop.framework.common.pojo.PageResult;

/**
 * 会员标签 Service 接口
 *
 * @author admin
 */
public interface UserTagService {

    /**
     * 创建会员标签
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createUserTag(@Valid UserTagCreateReqVO createReqVO);

    /**
     * 更新会员标签
     *
     * @param updateReqVO 更新信息
     */
    void updateUserTag(@Valid UserTagUpdateReqVO updateReqVO);

    /**
     * 删除会员标签
     *
     * @param id 编号
     */
    void deleteUserTag(Long id);

    /**
     * 获得会员标签
     *
     * @param id 编号
     * @return 会员标签
     */
    UserTagDO getUserTag(Long id);

    /**
     * 获得会员标签列表
     *
     * @param ids 编号
     * @return 会员标签列表
     */
    List<UserTagDO> getUserTagList(Collection<Long> ids);

    /**
     * 获得会员标签分页
     *
     * @param pageReqVO 分页查询
     * @return 会员标签分页
     */
    PageResult<UserTagDO> getUserTagPage(UserTagPageReqVO pageReqVO);

    /**
     * 获得会员标签列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 会员标签列表
     */
    List<UserTagDO> getUserTagList(UserTagExportReqVO exportReqVO);

    /**
     * 列表查询
     *
     * @param pageVO /
     * @return /
     */
    List<UserTagDO> getUserTagList(UserTagPageReqVO pageVO);
}
